{$FORM Tp1000100f1, p1000100u2.sfm}

uses unFrameCustomDict, unMain, cfIBUtils, need, cfWindows, p1000100u3,
  db, inifiles, sysutils, IBDatabase, IBQuery, windows,
  Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls,
  StdCtrls, dxExEdtr, dxCntner, dxTL, dxDBCtrl, dxDBTL,
  Buttons,
  Graphics, Controls, Forms, Dialogs, StdCtrls,
  ComCtrls, ExtCtrls, IBQuery, DB, ChequeList, FR,
  ScriptRes, Barcode,ZKassa, StrUtils, Windows, Classes,
  IBDataBase;

const ver = 'v20210914';

//function SetWindowLong(hWnd: HWND; nIndex: Integer; dwNewLong: Longint): Longint; stdcall; external 'user32.dll';
//function GetWindowLongA external 'user32.dll' name 'GetWindowLongA';

var
  frameOrders, frameOrderDetail, frameDoc: TFrameCustomDict;

//function sip_create(AppHandle: cardinal; domain, username, password, STUN, Proxy: string): cardinal; stdcall; external 'StnSip.DLL';
function SetWindowLongA(hWnd: HWND; nIndex: Integer; dwNewLong: Longint): Longint; stdcall; external 'user32.dll';
function GetWindowLongA(hWnd: HWND; nIndex: Integer): Longint; stdcall; external 'user32.dll';

procedure tmIconTimer(Sender: TObject);
var q: TIBQuery;
begin
  q:=CreateIBQuery(currDB, nil);
 try
  q.SQL.Text:='select count(1) as nn from I_ORDERS where status=1';
  q.Active:=true;
  if q.FieldByName('nn').AsInteger>0 then
  begin
    imGreen.Visible:=true;
    lbIcon.Caption:=q.FieldByName('nn').AsString;
    imGreen.Hint:=' : '+lbIcon.Caption;
    imBlue.Visible:=false;
    imRed.Visible:=false;
    exit;
  end;
  q.Active:=false;
  q.SQL.Text:='select count(1) as nn from I_ORDERS where status=-1 and ORDER_DATE>=dateadd(day, -2, current_date)';
  q.Active:=true;
  if q.FieldByName('nn').AsInteger>0 then
  begin
    imGreen.Visible:=false;
    imBlue.Visible:=false;
    imRed.Visible:=true;
    imRed.Hint:=' : '+lbIcon.Caption;
    lbIcon.Caption:=q.FieldByName('nn').AsString;
    exit;
  end;
  imGreen.Visible:=false;
  imBlue.Visible:=true;
  imRed.Visible:=false;
  lbIcon.Caption:='--';
 finally
  q.Free;
 end;
end;

procedure DoSettings(bSet: boolean);
var ini: TIniFile;
begin
  ini:=TIniFile.Create(extractfilepath(application.exename)+'site.ini');
 try
  if bSet then
  begin
    self.Height:=ini.ReadInteger('user_'+inttostr(UserID),'Height',self.Height);
    self.Top:=ini.ReadInteger('user_'+inttostr(UserID),'top',self.Top);
    if self.Height>(screen.WorkAreaHeight-50) then self.Height:=screen.WorkAreaHeight-50;
    if self.Top<0 then self.Top:=10;
    if self.Top>(screen.WorkAreaHeight-self.Height) then self.Top:=screen.WorkAreaHeight-self.Height-10;


    self.Width:=ini.ReadInteger('user_'+inttostr(UserID),'Width',self.Width);
    self.Left:=ini.ReadInteger('user_'+inttostr(UserID),'Left',self.Left);
    if self.Width>(screen.WorkAreaWidth-50) then self.Width:=screen.Width-50;
    if self.Left<0 then self.Left:=10;
    if self.Left>(screen.WorkAreaWidth-self.Width) then self.Left:=screen.WorkAreaWidth-self.Width-10;
  end
  else
  begin
    ini.WriteInteger('user_'+inttostr(UserID),'Height',self.Height);
    ini.WriteInteger('user_'+inttostr(UserID),'top',self.Top);
    ini.WriteInteger('user_'+inttostr(UserID),'Width',self.Width);
    ini.WriteInteger('user_'+inttostr(UserID),'Left',self.Left);
  end;
 finally
  ini.Free;
 end;
end;

function GetValue(frame: TFrameCustomDict; fieldname: string): variant;
begin
  result:=frame.PgbList.FocusedNode.Values[frame.PgbList.ColumnByFieldName(fieldname).Index];
end;

procedure SetDetailCaptions(bReset: boolean; doc_status: integer);
var q: TIBQuery;
    ORDER_UUID: string;
begin
  if bReset then
  begin
    lbCaptionOrderDetail.Caption:=' ';
    lbCaptionDoc.Caption:=' ';
    exit;
  end;
  q:=CreateIBQuery(CurrDB,nil);
 try
  ORDER_UUID:=trim(GetValue(frameOrders,'d$uuid'));
  q.SQL.Text:='select count(1) as cnt, sum(quant) as qnt, sum(I_PRICE*quant) as summa from i_order_detail where ORDER_UUID='''+ORDER_UUID+'''';
  q.Active:=true;
  lbCaptionOrderDetail.Caption:=' .'#13#10': '+q.FieldByName('cnt').AsString+', -: '+q.FieldByName('qnt').AsString+', : '+floattostr(q.FieldByName('summa').AsFloat);
  q.Active:=false;

  q.sql.text:='select
(select sum(quant) from i_order_detail where order_uuid='''+ORDER_UUID+''') as order_quant,
(select sum(quant) from doc_detail_active dda where part_id=0 and doc_id=(select doc_id from i_orders where d$uuid='''+ORDER_UUID+''')) as dda_quant
from rdb$database';
  q.Active:=true;
  if doc_status=-10 then
  begin
    lbWarning.Caption:='   ';
    pnQuantsWarning.Visible:=true;
    btnChangeQuant.Enabled:=false;
  end
  else
  begin
    case doc_status of
      0: begin
           lbWarning.Caption:='C    "",   ""';
           btnChangeQuant.Enabled:=false;
           pnQuantsWarning.Visible:=true;
         end;
      1: begin
           lbWarning.Caption:='C  !';
           btnChangeQuant.Enabled:=false;
           pnQuantsWarning.Visible:=true;
         end;
      2: lbWarning.Caption:='';
      else begin
             lbWarning.Caption:='    (status='+q.FieldByName('doc_status').AsString+')';
             btnChangeQuant.Enabled:=false;
             pnQuantsWarning.Visible:=true;
           end;
    end;
    if lbWarning.Caption='' then
    begin
      lbWarning.Caption:='!!!  -    !';
      pnQuantsWarning.Visible:=round(q.FieldByName('order_quant').AsFloat)<>round(q.FieldByName('dda_quant').AsFloat);
    end
  end
{  if not q.Eof then
  begin
    lbCaptionOrderDetail.Caption:=lbCaptionOrderDetail.Caption+#13#10#13#10' -    !';
    pnCaptionOrderDetail.Color:=$00413CFF;
  end
  else
    pnCaptionOrderDetail.Color:=$00FF8000;
}
  q.Active:=false;
  if doc_status=1 then
    q.SQL.Text:='select count(1) as cnt, sum(quant) as qnt, sum(PRICE*quant) as summa from doc_detail where doc_id='+trim(GetValue(frameOrders,'doc_id'))
  else
    q.SQL.Text:='select count(1) as cnt, sum(quant) as qnt, sum(PRICE*quant) as summa from doc_detail_active where doc_id='+trim(GetValue(frameOrders,'doc_id'));
  q.Active:=true;
  if doc_status=1 then
    lbCaptionDoc.Caption:='  . : '+q.FieldByName('cnt').AsString+', -: '+q.FieldByName('qnt').AsString+',  : '+floattostr(q.FieldByName('summa').AsFloat)
  else
    lbCaptionDoc.Caption:=' . : '+q.FieldByName('cnt').AsString+', -: '+q.FieldByName('qnt').AsString+',  : '+floattostr(q.FieldByName('summa').AsFloat);
 finally
  q.Free;
 end;
end;

procedure EnableButtons;
var status, i_status: integer;
begin
{0 -   
1 - 
2 -  
3 -   
4 - 
-1 - 
-2 - 
i_status
# 1 - 
# 3 - 
# 8 -  (    )
}
  i_status:=0;
  if (frameOrders.PgbList.FocusedNode=nil) or
     (frameOrders.qList.eof and frameOrders.qList.Bof) then status:=0
  else
  begin
    status:=frameOrders.PgbList.FocusedNode.Values[frameOrders.PgbList.ColumnByFieldname('status').Index];
    i_status:=GetValue(frameOrders,'i_status');
  end
  btnStatusInCompl.Enabled:=status=1;
  btnStatusReady.Enabled:=status=2;
  btnChanged.Enabled:=status=2;
//  btnStatusUncompl.Enabled:=status=-1;
  btnCancelOrder.Enabled:=not((status<0) or (status=4) or (status=0));
  btnSelling.Enabled:=status=3;
  btnChangePart.Enabled:=(status=2) or (status=3);
  btnChangeQuant.Enabled:=btnChangePart.Enabled;
  if not((i_status=1) or (i_status=8)) then
  begin
    btnStatusInCompl.Enabled:=false;
    btnChanged.Enabled:=false;
    btnStatusReady.Enabled:=false;
    btnSelling.Enabled:=false;
    btnChangePart.Enabled:=false;
    btnChangeQuant.Enabled:=false;
//    btnChangeQuant.Visible:=false;
//    btnCancelDoc.Visible:=true;
  end

  btnCancelDoc.Visible:=(status=5) or (not ((i_status=1) or (i_status=8)));
  btnChangeQuant.Visible:=not btnCancelDoc.Visible;
end;

function GetDocStatus(doc_id: int64): integer;
var q: TIBQuery;
begin
  q:=CreateIBQuery(CurrDB,nil);
 try
  q.SQL.Text:='select status from docs where id='+inttostr(doc_id);
  q.Active:=true;
  if q.Eof then //raise('   '+inttostr(doc_id));
    result:=-10
  else
    result:=q.FieldByName('status').Value;
 finally
  q.Free;
 end;
end;

procedure frameOrdersAfterScroll;
var sql: string;
    doc_status: integer;
    bReset: boolean;
begin
  doc_status:=2;
  if (frameOrders.PgbList.FocusedNode=nil) or
     (frameOrders.qList.eof and frameOrders.qList.Bof) then
  begin
    frameOrderDetail.SelectSQLText:='select * from vw_i_order_detail where ORDER_UUID=''no_order_focused!''';
    frameDoc.SelectSQLText:='select * from vw_doc_detail_active where doc_id=-9876543';
    bReset:=true; //    SetDetailCaptions(true, doc_status);
  end
  else
  begin
    frameOrderDetail.SelectSQLText:='select * from vw_i_order_detail where ORDER_UUID='''+trim(GetValue(frameOrders,'d$uuid'))+''' order by sname';
    doc_status:=GetDocStatus(GetValue(frameOrders,'doc_id'));
    if doc_status=1 then
    begin
      frameDoc.SelectSQLText:='select * from vw_doc_detail where doc_id='+trim(GetValue(frameOrders,'doc_id'))+' order by sname'
    end
    else
    begin
      frameDoc.SelectSQLText:='select * from vw_doc_detail_active where doc_id='+trim(GetValue(frameOrders,'doc_id'))+' order by sname';
    end
    bReset:=false;//    SetDetailCaptions(false, doc_status);
  end;
  case doc_status of
    1: pnCaptionDoc.Color:=$0062C400;//$007575FF;
    -1, -10: pnCaptionDoc.Color:=$007575FF;
    else pnCaptionDoc.Color:=$00FF8000;
  end;
  EnableButtons;
  SetDetailCaptions(bReset, doc_status);
//  SetDetailCaptions(false, doc_status);
  frameOrderDetail.ReInit;
  frameDoc.ReInit;
  self.Caption:='  '+ver;
end;

procedure p1000100f1Close(Sender: TObject; var Action: TCloseAction);
begin
  DoSettings(false);
//   -  ,  
//  action:=caFree;
end;

procedure ReinitOrders;
var s: string;
begin
  s:='';
  if chbNew.Checked then s:=s+'1,';
  if chbInCompl.Checked then s:=s+'2,';
  if chbReady.Checked then s:=s+'3,';
  if chbGived.Checked then s:=s+'4,';
  if chbCanceled.Checked then s:=s+'-1,';
  if chbChanged.Checked then s:=s+'5,';
  if chbInProcess.Checked then s:=s+'0,';
  if s<>'' then
    s:=' where status in ('+copy(s,1,length(s)-1)+')'
  else
    s:=' where status<>0'
  frameOrders.SelectSQLText:='select * from vw_i_orders '+s+' order by id';
  frameOrders.Reinit;
  self.Caption:='  '+ver;
  frameOrdersAfterScroll;
end;

procedure ButtonOnTaskPanel;
var hWnd: HWND;
    nIndex: Integer;
    dwNewLong: Longint;
begin
  hWnd:=self.Handle;
  nIndex:=-20; //GWL_EXSTYLE
  dwNewLong:=GetWindowLongA(hWnd, -20)//GWL_EXSTYLE
  dwNewLong:=dwNewLong or $40000; // WS_EX_APPWINDOW
  SetWindowLongA(hWnd, nIndex, dwNewLong);
//  SetWindowLongA(Handle, GWL_EXSTYLE, GetWindowLongA(Handle, GWL_EXSTYLE) or WS_EX_APPWINDOW);
end;

procedure p1000100f1Create(Sender: TObject);
var c: TWinControl;
    pn: TPanel;
begin
//  ButtonOnTaskPanel;

  frameOrders:=unFrameCustomDict.CreateFrame('I$ORDERS_DICT', self);
  c:=frameOrders.FindComponent('pnShow');
  c.Visible:=true;
  c:=frameOrders.FindComponent('pnBottom');
  c.Visible:=false;
  pn:=frameOrders.FindComponent('pnStat'); pn.BevelOuter:=bvNone; pn.Color:=pnTools.Color;
  pn:=frameOrders.FindComponent('ApnSearch'); pn.BevelOuter:=bvNone; pn.Color:=pnTools.Color;
  pn:=frameOrders.FindComponent('ApnFilter'); pn.BevelOuter:=bvNone; pn.Color:=pnTools.Color;
  pn:=frameOrders.FindComponent('AdvPanel1'); pn.BevelOuter:=bvNone; pn.Color:=pnTools.Color;
  pn:=frameOrders.FindComponent('AdvPanel3'); pn.BevelOuter:=bvNone; pn.Color:=pnTools.Color;
  pn:=frameOrders.FindComponent('ApnExport'); pn.BevelOuter:=bvNone; pn.Color:=pnTools.Color;
  pn:=frameOrders.FindComponent('ApnChilds'); pn.BevelOuter:=bvNone; pn.Color:=pnTools.Color;
  pn:=frameOrders.FindComponent('pnTop'); pn.BevelOuter:=bvNone; pn.Color:=pnTools.Color;

  frameOrderDetail:=unFrameCustomDict.CreateFrame('I$ORDER_DETAIL_DICT', self);
  c:=frameOrderDetail.FindComponent('pnShow');
  c.Visible:=true;
  c:=frameOrderDetail.FindComponent('pnBottom');
  c.Visible:=false;

  frameOrders.Parent:=pnClient;
  frameOrders.Align:=alClient;
  frameOrderDetail.Parent:=pnDetail;
  frameOrderDetail.Align:=alClient;
  frameOrders.init(frameOrders.Id);
  frameOrderDetail.init(frameOrderDetail.Id);
//  frameOrderDetail.ActionAfterScroll:='frameOrderDetailAfterScroll';

  frameDoc:=unFrameCustomDict.CreateFrame('I$ORDER_DOC_DICT', self);
  c:=frameDoc.FindComponent('pnShow');
  c.Visible:=true;
  c:=frameDoc.FindComponent('pnBottom');
  c.Visible:=false;
  frameDoc.Parent:=pnDoc;
  frameDoc.Align:=alClient;
  frameDoc.init(frameDoc.Id);
//  frameDoc.ActionAfterScroll:='frameDocAfterScroll';

  frameOrders.ActionAfterScroll:='frameOrdersAfterScroll';
  ReinitOrders;
  DoSettings(true);

  imGreen.Visible:=false;                                      
  imGreen.Top:=0; imGreen.Left:=0;
  lbIcon.Caption:='--';
  imBlue.Visible:=true;
  imBlue.Top:=0; imBlue.Left:=0;
  imRed.Visible:=false;
  imRed.Top:=0; imRed.Left:=0;

  pnQuantsWarning.Parent:=pnBottom;
  pnQuantsWarning.Align:=alTop;

  btnCancelDoc.Left:=pnCaptionDoc.ClientWidth-134;
  btnCancelDoc.Top:=8;

end;

procedure OrderDetailAfterScroll(source, dest: TFrameCustomDict);
begin
 try
  if source.PgbList.FocusedNode=nil then exit;
  if source.qList.EOF and source.qList.BOF then exit;
  if dest.PgbList.FocusedNode=nil then exit;
  if dest.qList.EOF and dest.qList.BOF then exit;
  if GetValue(source,'part_id')=0 then exit;
  if trim(GetValue(dest,'part_id'))=trim(GetValue(source,'part_id')) then exit;
  dest.LocateByKey(GetValue(source,'part_id'));
 except
 end;
end;

procedure frameOrderDetailAfterScroll;
begin
  OrderDetailAfterScroll(frameOrderDetail, frameDoc);
end;

procedure frameDocAfterScroll;
begin
  OrderDetailAfterScroll(frameDoc,frameOrderDetail);
end;

procedure chbNewClick(Sender: TObject);
begin
  ReinitOrders;
end;

//0 -   
//1 - 
//2 -  
//3 -   
//4 - 
//-1 - 
//-2 - 

procedure btnStatusInComplClick(Sender: TObject);
var// status: integer;
    q: TIBQuery;
    VNUM: int64;
begin
 try
  if frameOrders.PgbList.FocusedNode=nil then raise('  !');
  if frameOrders.qList.EOF and frameOrders.qList.BOF then raise(' ');
//  status:=GetValue(frameOrders,'status');
//  if status<>0 then raise('    ""!');
  q:=CreateIBQuery(CurrDB,nil);
 try
  q.SQL.Text:='select status, VNUM from i_orders where d$uuid='''+trim(GetValue(frameOrders,'d$uuid'))+'''';
  q.Active:=true;
  if q.FieldByName('status').AsInteger<>1 then raise('    ""!');
  VNUM:=q.FieldByName('VNUM').Value;
  q.Active:=false;

  if application.MessageBox('   '+trim(GetValue(frameOrders,'vnum'))+
    '  '+formatdatetime('dd.mm.yyyy hh:nn', GetValue(frameOrders,'ORDER_DATE'))+
    '  '+trim(GetValue(frameOrders,'CLIENT_NAME'))+#13#10'  " "?','',MB_ICONQUESTION+MB_OKCANCEL)<>idOk then exit;

  q.SQL.Text:='update i_orders set status=2 where d$uuid='''+trim(GetValue(frameOrders,'d$uuid'))+'''';
  q.ExecSQL;
  p1000100u3.CreateTask(q.Transaction,'SET_ORDER_STATUS','id='+inttostr(VNUM)+#13#10'status_id=6'#13#10'reservation_end_date='+floattostr(now+2));
  q.Transaction.Commit;
  frameOrders.ImmediateSelect;
  tmIconTimer(nil);
 finally
  q.Free;
 end
 except
  application.MessageBox(GLEM,'',MB_ICONSTOP)  ;
 end;
end;

procedure btnStatusReadyClick(Sender: TObject);
var q: TIBQuery;
    vnum: int64;
begin
 try
  if frameOrders.PgbList.FocusedNode=nil then raise('  !');
  if frameOrders.qList.EOF and frameOrders.qList.BOF then raise(' ');
  q:=CreateIBQuery(CurrDB,nil);
 try
  q.SQL.Text:='select status, vnum from i_orders where d$uuid='''+trim(GetValue(frameOrders,'d$uuid'))+'''';
  q.Active:=true;
  if q.FieldByName('status').AsInteger<>2 then raise('    " "!');
  VNUM:=q.FieldByName('VNUM').Value;
  q.Active:=false;

  if application.MessageBox('   '+trim(GetValue(frameOrders,'vnum'))+
    '  '+formatdatetime('dd.mm.yyyy hh:nn', GetValue(frameOrders,'ORDER_DATE'))+
    '  '+trim(GetValue(frameOrders,'CLIENT_NAME'))+#13#10'  "  "?','',MB_ICONQUESTION+MB_OKCANCEL)<>idOk then exit;

  q.SQL.Text:='update i_orders set status=3 where d$uuid='''+trim(GetValue(frameOrders,'d$uuid'))+'''';
  q.ExecSQL;                                  
  p1000100u3.CreateTask(q.Transaction,'SET_ORDER_STATUS','id='+inttostr(VNUM)+#13#10'status_id=5'#13#10'reservation_end_date='+floattostr(now+2));
  q.Transaction.Commit;
  frameOrders.ImmediateSelect;
  tmIconTimer(nil);
 finally
  q.Free;
 end
 except
  application.MessageBox(GLEM,'',MB_ICONSTOP)  ;
 end;
end;

function GetStatusInfo(acaption, promt: string; var s: string): boolean;
begin
  result:=false;
  while true do
  begin
    if not inputquery(acaption, promt, s) then exit;
    s:=trim(s);
    if s<>'' then break;
    application.MessageBox('    ',' ',MB_ICONINFORMATION);
  end;
  result:=true;
end;

procedure btnCancelOrderClick(Sender: TObject);
var q: TIBQuery;
    s: string;
    doc_id, vnum: int64;
    IgnoreDoc: boolean;
    i_status: integer;
begin
  IgnoreDoc:=false;
 try
  if frameOrders.PgbList.FocusedNode=nil then raise('  !');
  if frameOrders.qList.EOF and frameOrders.qList.BOF then raise(' ');
  i_status:=GetValue(frameOrders,'i_status');
  q:=CreateIBQuery(CurrDB,nil);
 try
//  q.SQL.Text:='select status, doc_id, (select d.status from docs d where d.id=o.doc_id) as doc_status from i_orders o where d$uuid='''+trim(GetValue(frameOrders,'d$uuid'))+'''';
  q.SQL.Text:='select o.vnum as vnum, o.status, o.doc_id, d.status as doc_status, (select username from users u where u.id=owner) as sowner, coalesce((select status from docs k where k.id=CHECKDOC_ID),-1000) as checkdoc_status from i_orders o left join docs d on d.id=o.doc_id where o.d$uuid='''+trim(GetValue(frameOrders,'d$uuid'))+'''';
  q.Active:=true;
  if q.FieldByName('checkdoc_status').AsInteger=0 then raise('   ,  !');

  if q.FieldByName('status').AsInteger<0 then raise('  !');
  if q.FieldByName('status').AsInteger=4 then raise('   !');
  if q.FieldByName('status').AsInteger=0 then raise('   !');
  vnum:=q.FieldByName('vnum').Value;
  if q.FieldByName('doc_status').IsNull then
  begin
    if application.MessageBox('   !'#13#10'     ""'#13#10'   ?','',MB_ICONWARNING+MB_YESNO)<>idYes then exit;
    IgnoreDoc:=true;
  end
  else
  begin
    case q.FieldByName('doc_status').AsInteger of
      1: begin
           case application.MessageBox('   !'#13#10'      ?','',MB_ICONQUESTION+MB_YESNOCANCEL) of
             idNo: IgnoreDoc:=true;
             idYes: IgnoreDoc:=false;
             else exit;
           end
         end
      0: begin
           case application.MessageBox('    "",       : '+q.FieldByName('sowner').AsString
             +#13#10'      ?','',MB_ICONQUESTION+MB_YESNOCANCEL) of
             idNo: IgnoreDoc:=true;
             idYes: IgnoreDoc:=false;
             else exit;
           end
         end
       -1: begin
             if application.MessageBox('    ""!'#13#10'   ?','',MB_ICONWARNING+MB_YESNO)<>idYes then exit;
             IgnoreDoc:=true;
           end
      2: IgnoreDoc:=false; //  
      else raise('   : '+q.FieldByName('doc_status').AsString);
    end
  end

  doc_id:=q.FieldByName('doc_id').Value;
  q.Active:=false;
  s:=' ';
  if not GetStatusInfo(' ','    '+trim(GetValue(frameOrders,'vnum'))+
    '  '+formatdatetime('dd.mm.yyyy hh:nn', GetValue(frameOrders,'ORDER_DATE'))+
    '  '+trim(GetValue(frameOrders,'CLIENT_NAME'))+'.'#13#10#13#10'    .', s) then exit;


  q.SQL.Text:='update i_orders set STATUS=:status, STATUS_INFO=:STATUS_INFO where d$uuid=:order_uuid';
  q.Prepare;
  q.ParamByName('status').AsInteger:=-1;
  q.ParamByName('order_uuid').AsString:=trim(GetValue(frameOrders,'d$uuid'));
  q.ParamByName('status_info').AsString:=s;
  q.ExecSQL;
  if not IgnoreDoc then
  begin
    q.sql.text:='select CANCEL_RESULT from pr_doc_cancel('+inttostr(doc_id)+', 1, 0, 0)';
    q.Active:=true;
  end;
{  q.SQL.Text:='select ERROR_CODE, ERROR_TEXT from PR_I_COMMIT_ORDER(:order_uuid,-1, :status_info, null)';
  q.Prepare;
  q.ParamByName('order_uuid').AsString:=trim(GetValue(frameOrders,'d$uuid'));                                                                 
  q.ParamByName('status_info').AsString:=s;
  q.Active:=true;
  if q.FieldByName('ERROR_CODE').AsInteger<>0 then raise('  : '+q.FieldByName('ERROR_CODE').AsString+' - '+q.FieldByName('ERROR_TEXT').AsString);
}
  if (i_status=1) or (i_status=8) then
  begin
    p1000100u3.CreateTask(q.Transaction,'SET_ORDER_STATUS','id='+inttostr(VNUM)+#13#10'status_id=3'#13#10'reservation_end_date='+floattostr(now+2)+#13#10'cancel_reason='+StrToJSON(s));
  end
  q.Transaction.Commit;
  frameOrders.ImmediateSelect;
  tmIconTimer(nil);
  if not IgnoreDoc then
    application.MessageBox('   "",    .','',MB_ICONINFORMATION)
  else
    application.MessageBox('   "",  .','',MB_ICONINFORMATION)
 finally
  q.Free;
 end
 except
  application.MessageBox(GLEM,'',MB_ICONSTOP)  ;
 end;
end;

procedure p1000100f1Show(Sender: TObject);
begin
  frameOrders.ActionAfterScroll:='frameOrdersAfterScroll';
//  frameOrderDetail.ActionAfterScroll:='frameOrderDetailAfterScroll';
//  frameDoc.ActionAfterScroll:='frameDocAfterScroll';
  frameOrders.ImmediateSelect;
end;
{------------------------
function CreateCheckDocFromRepriceDoc_Back20210730(trn: TIBTransaction; doc_id: int64): int64;
var qList, qWork, qUpd: TIBQuery;
    s: string;
begin
 try
  qList:=CreateIBQueryTrn(trn,nil);
  qWork:=CreateIBQueryTrn(trn,qList);
  qUpd:=CreateIBQueryTrn(trn,qList);
 try
  s:=' (  ...)';
  qList.SQL.Text:='select DOC_ID from pr_newdoc(3,-1,0, null, null,'+inttostr(SessionID)+')';
  qList.Active:=true;
  result:=strtoint64(qList.FieldByName('doc_id').AsString);
  qList.Active:=false;
  s:=' (   ...)';
  qWork.SQL.Text:='update docs set status=2 where id='+inttostr(result);
  qWork.ExecSQL;
  s:=' ( ...)';
  qWork.sql.text:='select id, msg from pr_rashodpart('+inttostr(result)+',:part_id,:quant,null,null,null,null)';
  qWork.Prepare;
  qList.SQL.Text:='select part_id, quant from doc_detail where quant>0 and doc_id='+inttostr(doc_id);
  qList.Active:=true;
  if qList.Bof and qList.eof then raise('      !');
  while not qList.eof do
  begin
    qWork.Active:=false;
    s:=' ( '+qList.fieldbyname('part_id').AsString+'  - '+qList.fieldbyname('quant').AsString+')';
    qWork.ParamByName('part_id').Value:=qList.FieldByName('part_id').Value;
    qWork.ParamByName('quant').Value:=qList.FieldByName('quant').Value;
    qWork.Active:=true;
    if qWork.FieldByName('id').AsInteger<=0 then raise('    : '+qWork.FieldByName('msg').AsString);
    qList.next;
  end;
  s:='';
 finally
  qList.Free;
 end;
 except
  raise(' '+s+': '+GLEM);
 end
end;
--------------------}
function CreateCheckDocFromRepriceDoc(trn: TIBTransaction; doc_id: int64): int64;
var qList, qWork, qUpd: TIBQuery;
    s: string;
    slDocs: TStringList;
begin
 try
  qList:=CreateIBQueryTrn(trn,nil);
  qWork:=CreateIBQueryTrn(trn,qList);
  qUpd:=CreateIBQueryTrn(trn,qList);
  slDocs:=TStringList.Create;
 try
  s:=' (  ...)';
  qList.SQL.Text:='select DOC_ID from pr_newdoc(3,-1,0, null, null,'+inttostr(SessionID)+')';
  qList.Active:=true;
  result:=strtoint64(qList.FieldByName('doc_id').AsString);
  qList.Active:=false;
  s:=' (   ...)';
  qWork.SQL.Text:='update docs set status=2 where id='+inttostr(result);
  qWork.ExecSQL;
  s:=' ( ...)';
  qWork.sql.text:='select id, msg from pr_rashodpart(:doc_id,:part_id,:quant,null,null,null,null)';
  qWork.Prepare;
  qList.SQL.Text:='select part_id, quant, base_agent_id from doc_detail where quant>0 and doc_id='+inttostr(doc_id);
  qList.Active:=true;
  if qList.Bof and qList.eof then raise('      !');
{--      ,      base_agent_id --}
  qWork.Active:=false;
  s:=' ( '+qList.fieldbyname('part_id').AsString+'  - '+qList.fieldbyname('quant').AsString+' base_agent_id='+qList.fieldbyname('base_agent_id').AsString+')';
  qWork.ParamByName('doc_id').Value:=result;
  qWork.ParamByName('part_id').Value:=qList.FieldByName('part_id').Value;
  qWork.ParamByName('quant').Value:=qList.FieldByName('quant').Value;
  qWork.Active:=true;
  if qWork.FieldByName('id').AsInteger<=0 then raise('    : '+qWork.FieldByName('msg').AsString);
  slDocs.values[qList.fieldbyname('base_agent_id').AsString]:=inttostr(result);
  qList.next;
  while not qList.eof do
  begin
    if slDocs.Values[qList.fieldbyname('base_agent_id').AsString]='' then
    begin
      qWork.SQL.Text:='select DOC_ID from pr_newdoc(3,-1,0, null, null,'+inttostr(SessionID)+')';
      qWork.Active:=true;
      slDocs.values[qList.fieldbyname('base_agent_id').AsString]:=qWork.FieldByName('doc_id').AsString;
      qWork.Active:=false;
      s:=' (    (LINK_ID)...)';
      qWork.SQL.Text:='update docs set status=2, link_id='+inttostr(result)+' where id='+slDocs.values[qList.fieldbyname('base_agent_id').AsString];
      qWork.ExecSQL;
      qWork.sql.text:='select id, msg from pr_rashodpart(:doc_id,:part_id,:quant,null,null,null,null)';
      qWork.Prepare;
    end;
    qWork.Active:=false;
    s:=' ( '+qList.fieldbyname('part_id').AsString+'  - '+qList.fieldbyname('quant').AsString+' base_agent_id='+qList.fieldbyname('base_agent_id').AsString+')';
    qWork.ParamByName('doc_id').Value:=slDocs.Values[qList.fieldbyname('base_agent_id').AsString];
    qWork.ParamByName('part_id').Value:=qList.FieldByName('part_id').Value;
    qWork.ParamByName('quant').Value:=qList.FieldByName('quant').Value;
    qWork.Active:=true;
    if qWork.FieldByName('id').AsInteger<=0 then raise('    : '+qWork.FieldByName('msg').AsString);
    qList.next;
  end;
  s:='';
 finally
  slDocs.Free;
  qList.Free;
 end;
 except
  raise(' '+s+': '+GLEM);
 end
end;
{  20210802
procedure RunCurCheck;
var i: integer;
begin
  if chequelist.IsEmpty then exit;
  for i:=0 to chequelist.items[0].count - 1 do
  begin
    chequelist.items[0].p_index := i;
    Add2Cheque(chequelist.items[0].P_ID,chequelist.items[0].P_Quant);
  end;
end;
}

procedure RunCurCheck;
var i, j: integer;
begin
  if chequelist.IsEmpty then exit;
  for j:=0 to chequelist.Count - 1 do
  begin
    for i:=0 to chequelist.items[j].count - 1 do
    begin
      chequelist.items[j].p_index := i;
      Add2Cheque(chequelist.items[j].P_ID,chequelist.items[j].P_Quant);
    end;
  end;
end;

procedure btnSellingClick(Sender: TObject);
var q: TIBQuery;
    order_uuid: string;
    doc_id, checkdoc_id: int64;
begin
  q:=CreateIBQuery(CurrDB,nil);
 try
 try
  if frameOrders.PgbList.FocusedNode=nil then raise('  !');
  if frameOrders.qList.EOF and frameOrders.qList.BOF then raise(' ');
  if not chequelist.IsEmpty then raise('  !      .');

  order_uuid:=trim(GetValue(frameOrders,'d$uuid'));
  q.SQL.Text:='select status, doc_id from i_orders where d$uuid='''+order_uuid+'''';
  q.Active:=true;
  if q.FieldByName('status').AsInteger<>3 then raise('    "  "!');
  doc_id:=strtoint64(q.FieldByName('doc_id').AsString);
  q.Active:=false;
  if application.MessageBox('   '+trim(GetValue(frameOrders,'vnum'))+
    '  '+formatdatetime('dd.mm.yyyy hh:nn', GetValue(frameOrders,'ORDER_DATE'))+
    '  '+trim(GetValue(frameOrders,'CLIENT_NAME'))+'.','',MB_ICONWARNING+MB_OKCANCEL)<>idOK then exit;
//    
  q.SQL.Text:='select status, parent_id from docs where id='+inttostr(doc_id);
  q.Active:=true;
  if q.FieldByName('status').AsInteger=2 then //  ,  
  begin
    q.SQL.Text:='execute procedure PR_DOC_COMMIT('+inttostr(doc_id)+','+inttostr(SessionId)+')';
    q.ExecSQL;
  end
  else
  begin
    if q.FieldByName('status').AsInteger=1 then //   ,     ,
    begin //      ,   ,      
      if application.MessageBox('    ,   ""  .'#13#10+
        '   ,       .'#13#10'    ?','',MB_ICONWARNING+MB_OKCANCEL)<>idOK then exit;
    end
    else
      raise('   : '+q.FieldByName('status').aSsTRING);
  end;
//   
  checkdoc_id:=CreateCheckDocFromRepriceDoc(q.Transaction, doc_id);
  q.SQL.Text:='update i_orders set CHECKDOC_ID='+inttostr(CHECKDOC_ID)+' where d$uuid='''+order_uuid+'''';
  q.ExecSQL;
  q.Transaction.Commit;
//    s:=' ...';
  OpenDefByID(checkdoc_id);
  RunCurCheck;
  frameOrders.ImmediateSelect;
  tmIconTimer(nil);
  Close;
//  !!      PR_I_DOC_COMMIT
//  application.MessageBox('   "",    .','',MB_ICONINFORMATION);
 except
  if q.Transaction.Active then q.Transaction.Commit;
  application.MessageBox(GLEM,'',MB_ICONSTOP);
 end;
 finally
  q.Free;
 end
end;

procedure btnStatusUncomplClick(Sender: TObject);
var q: TIBQuery;
begin
 try
  if frameOrders.PgbList.FocusedNode=nil then raise('  !');
  if frameOrders.qList.EOF and frameOrders.qList.BOF then raise(' ');
  q:=CreateIBQuery(CurrDB,nil);
 try
  q.SQL.Text:='select status from i_orders where d$uuid='''+trim(GetValue(frameOrders,'d$uuid'))+'''';
  q.Active:=true;
  if q.FieldByName('status').AsInteger<>-1 then raise('    ""!');
  q.Active:=false;

  if application.MessageBox('   '+trim(GetValue(frameOrders,'vnum'))+
    '  '+formatdatetime('dd.mm.yyyy hh:nn', GetValue(frameOrders,'ORDER_DATE'))+
    '  '+trim(GetValue(frameOrders,'CLIENT_NAME'))+#13#10'  ""?','',MB_ICONQUESTION+MB_OKCANCEL)<>idOk then exit;

  q.SQL.Text:='update i_orders set status=-2 where d$uuid='''+trim(GetValue(frameOrders,'d$uuid'))+'''';
  q.ExecSQL;
  q.Transaction.Commit;
  frameOrders.ImmediateSelect;
  tmIconTimer(nil);
 finally
  q.Free;
 end
 except
  application.MessageBox(GLEM,'',MB_ICONSTOP)  ;
 end;                                    
end;

procedure CheckQuants;
var q: TIBQuery;
    order_uuid: string;
    doc_id: int64;
begin
  if frameOrders.qList.Eof and frameOrders.qList.bof then exit;
  if frameOrders.PgbList.focusednode=nil then exit;
  order_uuid:=trim(GetValue(frameOrders,'d$uuid'));
  q:=CreateIBQuery(currDB,nil);
 try
  q.SQL.TExt:='select * from(
select od.ware_id, sum(od.quant) as order_quant, sum(dda.quant) as dda_quant from i_order_detail od join doc_detail_active dda on od.ware_id=dda.ware_id
where od.order_uuid='''+order_uuid+''' and dda.doc_id=(select doc_id from i_orders where d$uuid='''+order_uuid+''') and dda.part_id=0
 group by od.ware_id) t where t.order_quant<>dda_quant';
  q.Active:=true;
 finally
  q.Free;  
 end;
end;

procedure ChangeQuant(order_uuid: string; part_id: int64; price, quant: double);
var qWork: TIBQuery;
    active_id: int64;
begin
  qWork:=CreateIBQuery(currDB,nil);
 try
  qWork.SQL.Text:='select realquant, quant from warebase where part_id='+inttostr(part_id);
  qWork.Active:=true;
  if not cfWindows.InputFloatQuery(' ','  (: '+inttostr(part_id)+'; : '+qWork.fieldbyname('quant').AsString+')',quant,0) then exit;
  qWork.active:=false;
 try
//    
//  qWork.SQL.Text:='select ERROR_CODE, ERROR_TEXT from MA$PR_ORDER_ADD(null,:ORDER_UUID,:PART_ID,:QUANT,:PRICE)';

  qWork.SQL.Text:='select id, msg from pr_correctpart((select doc_id from I_ORDERS where d$uuid=:order_uuid),:part_id,:quant)';
  qWork.Prepare;
  qWork.ParamByName('order_uuid').AsString:=order_uuid;
  qWork.ParamByName('part_id').value:=part_id;
  qWork.ParamByName('QUANT').value:=quant;
//  qWork.ParamByName('price').value:=price;
  qWork.active:=true;
  if qWork.eof then raise(' ');
  active_id:=qWork.FieldByName('id').value;
  if active_id<=0 then
  begin
    application.MessageBox(qWork.FieldByName('msg').AsString,'  ',MB_ICONSTOP);
    exit;
  end;
  qWork.Active:=false;
  if price=0 then
  begin
    qWork.SQL.Text:='select i_price from i_order_detail where ware_id=(select ware_id from parts p where p.id='+inttostr(part_id)+')';
    qWork.Active:=true;
    price:=qWork.FieldByName('i_price').AsFloat;
    if price=0 then raise('  -!');
  end;
  qWork.Active:=false;
//  qWork.SQL.Text:='update doc_detail_active set price=:price, summa=:price*quant where id=:active_id';
  qWork.SQL.Text:='update doc_detail_active set price=:price where id=:active_id';
  qWork.Prepare;
  qWork.ParamByName('price').value:=price;
  qWork.ParamByName('active_id').value:=active_id;
  qWork.ExecSQL;

  qWork.Active:=false;
  qWork.SQL.Text:='select id from group_detail where group_id=-1000 and grouptable_id='+inttostr(active_id)+' and grouptable=''DOC_DETAIL_ACTIVE''';
  qWork.Active:=true;
  if qWork.eof then
  begin
    qWork.Active:=false;
    qWork.SQL.Text:='update or insert into group_detail (group_id,parent_id,grouptable_id,grouptable) values (-1000, 0, '+inttostr(active_id)+', ''DOC_DETAIL_ACTIVE'') matching (GROUP_ID,GROUPTABLE_ID,GROUPTABLE)';
    qWork.ExecSQL;
  end

//  qWork.SQL.Text:='update i_orders o set summa=(select sum(i_price*quant) from i_order_detail where order_uuid=o.d$uuid) where o.d$uuid='''+order_uuid+'''';
//  qWork.ExecSQL;
  qWork.Transaction.Commit;
  frameOrders.ImmediateSelect;
//  frameOrdersAfterScroll;
 except
  qWork.Transaction.Rollback;
  raise(GLEM);
 end
 finally
  qWork.Free;
 end;
end;

function GetWDICT_ID(sid: string): int64;
var q: TIBQuery;
begin
  q:=CreateIBQuery(currDB,nil);
 try
  q.sql.text:='select id from sp$wdicts where sid='''+sid+'''';
  q.active:=true;
  result:=q.FieldByName('id').Value;
 finally
  q.Free;
 end;
end;

procedure btnChangePartClick(Sender: TObject);
var qParams: TIBQuery;
    id, s, ware_id, order_uuid, part_list: string;
    price, quant: double;
begin
  if frameOrderDetail.qList.Eof and frameOrderDetail.qList.bof then exit;
  if frameOrderDetail.PgbList.focusednode=nil then exit;
  if not ((frameOrders.PgbList.focusednode.values[frameOrders.PgbList.ColumnByFieldName('status').Index]=2)
       or (frameOrders.PgbList.focusednode.values[frameOrders.PgbList.ColumnByFieldName('status').Index]=3)) then
  begin
    application.MessageBox('     : " "  "  "!','',MB_ICONINFORMATION);
    exit;
  end;
  qParams:=CreateIBQuery(currDB,nil);
 try
  ware_id:=frameOrderDetail.PgbList.focusednode.values[frameOrderDetail.PgbList.ColumnByFieldName('ware_id').Index];
  order_uuid:=frameOrderDetail.PgbList.focusednode.values[frameOrderDetail.PgbList.ColumnByFieldName('order_uuid').Index];
  price:=frameOrderDetail.PgbList.focusednode.values[frameOrderDetail.PgbList.ColumnByFieldName('i_price').Index];
//  qParams.SQL.Text:='select id, ware_id from parts where d$uuid='''+s+'''';
  qParams.SQL.Text:='select list(part_id) as part_list from I_ORDER_DETAIL od where order_uuid='''+order_uuid+''' and ware_id='''+ware_id+'''';
  qParams.Active:=true;
  if qParams.EOF then raise('    PART_UUID!');
//  ware_id:=qParams.FieldByName('ware_id').AsString;
  part_list:=qParams.FieldByName('part_list').AsString;
  qParams.Active:=false;
  qParams.SQL.Text:='select * from rdb$database where ''1''=:ware_id and 2=:quant and ''123''=:part_list';
  qParams.Prepare;
  qParams.ParamByName('ware_id').AsString:=ware_id;
//  qParams.ParamByName('quant').value:=frameOrderDetail.PgbList.focusednode.values[frameOrderDetail.PgbList.ColumnByFieldName('quant').Index];
  qParams.ParamByName('part_list').AsString:=part_list;
  id:=0; s:='';

  if not unFrameCustomDict.GetWDict(GetWDICT_ID('I$ORDER_PARTS_DICT'), id, s, '', qParams.Params) then exit;
  quant:=1;
  ChangeQuant(order_uuid, strtoint64(id),  price, quant);
 finally
  qParams.Free;
 end;
end;

procedure btnChangeQuantClick(Sender: TObject);
var // qWork: TIBQuery;
    id, s, ware_id, order_uuid: string;
    price, quant: double;
    part_id: int64;
begin
  if frameDoc.qList.Eof and frameDoc.qList.bof then exit;
  if frameDoc.PgbList.focusednode=nil then exit;
  if not ((frameOrders.PgbList.focusednode.values[frameOrders.PgbList.ColumnByFieldName('status').Index]=2)
       or (frameOrders.PgbList.focusednode.values[frameOrders.PgbList.ColumnByFieldName('status').Index]=3)) then
  begin
    application.MessageBox('     : " "  "  "!','',MB_ICONINFORMATION);
    exit;
  end;
  part_id:=frameDoc.PgbList.focusednode.values[frameDoc.PgbList.ColumnByFieldName('part_id').Index];
  if part_id=0 then
    part_id:=frameDoc.PgbList.focusednode.values[frameDoc.PgbList.ColumnByFieldName('MOTHERPART_ID').Index];
  price:=0; //frameDoc.PgbList.focusednode.values[frameOrderDetail.PgbList.ColumnByFieldName('i_price').Index];
  order_uuid:=trim(GetValue(frameOrders,'d$uuid'));
  quant:=abs(frameDoc.PgbList.focusednode.values[frameDoc.PgbList.ColumnByFieldName('quant').Index]);
  ChangeQuant(order_uuid, part_id, price, quant);
{
  if frameOrderDetail.qList.Eof and frameOrderDetail.qList.bof then exit;
  if frameOrderDetail.PgbList.focusednode=nil then exit;
  if not ((frameOrders.PgbList.focusednode.values[frameOrders.PgbList.ColumnByFieldName('status').Index]=2)
       or (frameOrders.PgbList.focusednode.values[frameOrders.PgbList.ColumnByFieldName('status').Index]=3)) then
  begin
    application.MessageBox('     : " "  "  "!','',MB_ICONINFORMATION);
    exit;
  end;
  part_id:=frameOrderDetail.PgbList.focusednode.values[frameOrderDetail.PgbList.ColumnByFieldName('part_id').Index];
  price:=frameOrderDetail.PgbList.focusednode.values[frameOrderDetail.PgbList.ColumnByFieldName('i_price').Index];
  order_uuid:=frameOrderDetail.PgbList.focusednode.values[frameOrderDetail.PgbList.ColumnByFieldName('order_uuid').Index];
  quant:=frameOrderDetail.PgbList.focusednode.values[frameOrderDetail.PgbList.ColumnByFieldName('quant').Index];
  ChangeQuant(order_uuid, part_id, price, quant);
}
end;

procedure Button1Click(Sender: TObject);
var
  doc_id,LengthCheak,i,j, StrCount : integer;
  iq: TIBQuery;
  order_summa,sum_quant : float;
  str_temp,Tovar,order_uuid,t : string;

begin
   //exit; //      150 "    "
   FR_Activate(0);
try
  if frameOrders.PgbList.FocusedNode=nil then raise('  !');
  if frameOrders.qList.EOF and frameOrders.qList.BOF then raise(' ');
  if not chequelist.IsEmpty then raise('  !      .');
  order_uuid:=trim(GetValue(frameOrders,'d$uuid'));

  iq:=CreateIBQuery(CurrDB,nil);
 try
  t := 'select io.vnum, cast(io.order_date as DM_date) as order_date,io.summa as order_summa, iod.sname, iod.seria, iod.godendo, '+
        '(select COALESCE(svalue,'''') from pr_getattribute(''store_string'', iod.name_id)) as store_string, '+
        'iod.quant,iod.i_price as price,(iod.quant*iod.i_price) as detail_summa  from vw_i_order_detail iod '+
        'left join vw_i_orders io on io.d$uuid=iod.order_uuid '+
        'where io.d$uuid='''+trim(GetValue(frameOrders,'d$uuid'))+''' order by iod.sname';
  iq.SQL.Text:=t;
  //ShowMessage(t);
  iq.Active:=true;
  if not (iq.Eof) then
    begin
     //  
     LengthCheak := FR_LineLength;
     str_temp := dupestring('*',LengthCheak)+#13#10;
     str_temp := str_temp + myFormatString(' ',' ',' ',LengthCheak,0,true)+#13#10;
     str_temp := str_temp + myFormatString(' '+Trim(iq.FieldByName('vnum').AsString)+' '+iq.FieldByName('order_date').AsString,' ',' ',LengthCheak,0,true)+#13#10;
     str_temp := str_temp + dupestring('*',LengthCheak)+#13#10;
     order_summa := iq.FieldByName('order_summa').AsFloat;
    end;
   //ShowMessage(str_temp);
   //iq.Last;
   //iq.First;
   //for j:=0 to iq.RecordCount-1 do
  j :=0; sum_quant := 0;
  iq.Active:=false;
  iq.Active:=true;
   while not (iq.Eof) do
    begin
     inc(j);
     //ShowMessage('1');
     Tovar := Trim(iq.FieldByName('sname').AsString);
     if Length(Tovar) > LengthCheak then
     begin
       StrCount := Length(Tovar) div LengthCheak;
       for i:= 0 to StrCount do
       begin
         str_temp := str_temp + copy(Tovar,1,LengthCheak)+#13#10;
         Tovar := copy(Tovar, LengthCheak+1, Length(Tovar) - LengthCheak);
       end;
     end;
     str_temp := str_temp + myFormatString(IntToStr(j)+'. '+Tovar,' ',' ',LengthCheak,1,true)+#13#10;
     str_temp := str_temp + myFormatString(' '+Trim(iq.FieldByName('seria').AsString) + ' # '+Trim(iq.FieldByName('store_string').AsString),' ',' ',LengthCheak,1,true)+#13#10;
     str_temp := str_temp + myFormatString(' ', Format('%s X %.2f = %.2f', [iq.FieldByName('QUANT').AsString, iq.FieldByName('price').AsFloat, iq.FieldByName('detail_summa').AsFloat]),' ',LengthCheak,1,true)+#13#10;
     sum_quant :=sum_quant+iq.FieldByName('QUANT').AsFloat;
     iq.Next;//  .Next;
    end;
    //ShowMessage('3');
    str_temp := str_temp + dupestring('-',LengthCheak)+#13#10;

   str_temp := str_temp + myFormatString('   '+Trim(iq.FieldByName('vnum').AsString),' ',' ',LengthCheak,1,true)+#13#10;
   str_temp := str_temp + myFormatString('',' ='+Format('%s',[IntToStr(j)]),' ',LengthCheak,1,true)+#13#10;
   str_temp := str_temp + myFormatString('-',' ='+Format('%s',[FloatToStr(sum_quant)]),' ',LengthCheak,1,true)+#13#10;
   str_temp := str_temp + myFormatString('',' ='+Format('%.2f',[order_summa]),' ',LengthCheak,1,true)+#13#10;

   str_temp := str_temp + dupestring('*',LengthCheak)+#13#10;
   str_temp := str_temp + myFormatString(DateToStr(Date)+' '+TimeToStr(Time),'#'+IntToStr(FR_CHEQUENUMBER),' ',LengthCheak,1,true)+#13#10;
finally
  iq.Free;
 end
 except
  application.MessageBox(GLEM,'',MB_ICONSTOP)  ;
 end;

   str_temp := str_temp + dupestring(' ',LengthCheak)+#13#10;
   //str_temp := str_temp + dupestring(' ',LengthCheak)+#13#10;
   //ShowMessage(str_temp);
   //exit;
   //  
   FR_STRING_SET(str_temp);
   //   
   FR_PRINTSTRING;
   FR_GETADVTEXT;
   FR_PRINTSTRING;
   FR_PRINTCLICHE;
   //
   //FR_NUMBER_SET(2);
   //FR_FEEDTAPE;
   //
   FR_BOOLEAN_SET(false);
   FR_CUTTAPE;
   // 
   FR_DEACTIVATE;
end;

procedure imBlueClick(Sender: TObject);
begin
  Show;
  BringToFront;
end;

procedure Button2Click(Sender: TObject);
begin
  RunCurCheck;
end;

procedure btnChangedClick(Sender: TObject);
var q: TIBQuery;
    vnum: int64;
    order_uuid: string;
    n: integer;
    s: string;
begin
 try
  if frameOrders.PgbList.FocusedNode=nil then raise('  !');
  if frameOrders.qList.EOF and frameOrders.qList.BOF then raise(' ');
  q:=CreateIBQuery(CurrDB,nil);
 try
  order_uuid:=trim(GetValue(frameOrders,'d$uuid'));
  q.SQL.Text:='select status, vnum from i_orders where d$uuid='''+order_uuid+'''';
  q.Active:=true;
  if q.FieldByName('status').AsInteger<>2 then raise('    " "!');
  VNUM:=q.FieldByName('VNUM').Value;
  q.Active:=false;

  q.SQL.Text:='select i_id, QUANT, QUANT_REZERVED, sname from VW_I_ORDER_DETAIL where order_uuid='''+order_uuid+'''';
  q.active:=true;
  n:=0;  s:='items=';
  while not q.EOF do
  begin
    if round(q.FieldByName('quant').AsFloat)<round(q.FieldByName('QUANT_REZERVED').AsFloat) then
      raise(' "'+q.FieldByName('sname').AsString+'" ('+q.FieldByName('i_id').AsString+') -  ,  !');
    if round(q.FieldByName('quant').AsFloat)<>round(q.FieldByName('QUANT_REZERVED').AsFloat) then
      n:=n+1;
    s:=s+q.FieldByName('i_id').AsString+'='+inttostr(round(q.FieldByName('QUANT_REZERVED').AsFloat))+#9;
    q.Next;
  end
  if n=0 then raise('   -    !');

  if application.MessageBox('   '+trim(GetValue(frameOrders,'vnum'))+
    '  '+formatdatetime('dd.mm.yyyy hh:nn', GetValue(frameOrders,'ORDER_DATE'))+
    '  '+trim(GetValue(frameOrders,'CLIENT_NAME'))+#13#10'  ""?'#13#10'       ,    !','',MB_ICONQUESTION+MB_OKCANCEL)<>idOk then exit;

  q.SQL.Text:='update i_orders set status=5 where d$uuid='''+trim(GetValue(frameOrders,'d$uuid'))+'''';
  q.ExecSQL;
  p1000100u3.CreateTask(q.Transaction,'SET_ORDER_STATUS','id='+inttostr(VNUM)+#13#10'status_id=7'#13#10'reservation_end_date='+floattostr(now+2)+#13#10+s);
  q.Transaction.Commit;
  frameOrders.ImmediateSelect;
  tmIconTimer(nil);
 finally
  q.Free;
 end
 except
  application.MessageBox(GLEM,'',MB_ICONSTOP)  ;
 end;
end;

procedure btnCancelDocClick(Sender: TObject);
var q: TIBQuery;
    s: string;
    doc_id: int64;
    i_status: integer;
begin
 try
  if frameOrders.PgbList.FocusedNode=nil then raise('  !');
  if frameOrders.qList.EOF and frameOrders.qList.BOF then raise(' ');
  i_status:=GetValue(frameOrders,'i_status');
  q:=CreateIBQuery(CurrDB,nil);
 try
  q.SQL.Text:='select o.vnum as vnum, o.status, o.doc_id, d.status as doc_status, (select username from users u where u.id=owner) as sowner, coalesce((select status from docs k where k.id=CHECKDOC_ID),-1000) as checkdoc_status from i_orders o left join docs d on d.id=o.doc_id where o.d$uuid='''+trim(GetValue(frameOrders,'d$uuid'))+'''';
  q.Active:=true;
  if q.FieldByName('checkdoc_status').AsInteger=0 then raise('   ,  !');

  if q.FieldByName('status').AsInteger<0 then raise('  !');
  if q.FieldByName('status').AsInteger=4 then raise('   !');
  if q.FieldByName('status').AsInteger=0 then raise('   !');
  if q.FieldByName('doc_status').IsNull then
  begin
    application.MessageBox('   !'#13#10'     ""','',MB_ICONINFORMATION);
    exit;
  end

  case q.FieldByName('doc_status').AsInteger of
      1: begin
           application.MessageBox('   !','',MB_ICONINFORMATION);
           exit;
         end
      0: begin
           if application.MessageBox('    "",       : '+q.FieldByName('sowner').AsString
             +#13#10'  ?','',MB_ICONQUESTION+MB_YESNO)=idNo then exit;
         end
       -1: begin
             application.MessageBox('    ""!','',MB_ICONINFORMATION);
             exit;
           end
        2: sleep(1);//  
      else raise('   : '+q.FieldByName('doc_status').AsString);
  end

  doc_id:=q.FieldByName('doc_id').Value;
  q.Active:=false;

  if application.MessageBox('    (doc_id='+inttostr(doc_id)+')?','',MB_ICONQUESTION+MB_YESNO)=idNo then exit;

  q.sql.text:='select CANCEL_RESULT from pr_doc_cancel('+inttostr(doc_id)+', 1, 0, 0)';
  q.Active:=true;
  q.Transaction.Commit;
  frameOrders.ImmediateSelect;
  tmIconTimer(nil);
  application.MessageBox('  .','',MB_ICONINFORMATION);
 finally
  q.Free;
 end
 except
  application.MessageBox(GLEM,'',MB_ICONSTOP)  ;
 end;
end;

begin
end;

{

ALTER TABLE I_ORDER_DETAIL ADD WARE_ID DM_UUID_NULL;
update I_ORDER_DETAIL od set ware_id=(select ware_id from parts p where p.id=od.part_id)
ALTER TABLE I_ORDER_DETAIL ALTER COLUMN WARE_ID TYPE DM_UUID;

}
